// SPDX-License-Identifier: GPL-3.0-or-later

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Copyright (C) 2013 - 2024, nymea GmbH
* Copyright (C) 2024 - 2025, chargebyte austria GmbH
*
* This file is part of nymea-energy-plugin-nymea.
*
* nymea-energy-plugin-nymea.s free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* nymea-energy-plugin-nymea.s distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with nymea-energy-plugin-nymea. If not, see <https://www.gnu.org/licenses/>.
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef TIMEFRAME_H
#define TIMEFRAME_H

#include <QList>
#include <QDebug>
#include <QDateTime>

class TimeFrame {
public:
    TimeFrame();
    TimeFrame(const QDateTime &startDateTime, const QDateTime &endDateTime);

    QDateTime startDateTime() const;
    void setStartDateTime(const QDateTime &startDateTime);

    QDateTime endDateTime() const;
    void setEndDateTime(const QDateTime &endDateTime);

    uint durationMinutes() const;

    bool isValid() const;

    bool isActive(const QDateTime &dateTime) const;

    bool operator==(const TimeFrame &other) const {
        return m_startDateTime == other.startDateTime() && m_endDateTime == other.endDateTime();
    }

    bool operator!=(const TimeFrame &other) const {
        return !(*this == other);
    }

protected:
    QDateTime m_startDateTime;
    QDateTime m_endDateTime;

};

typedef QList<TimeFrame> TimeFrames;
Q_DECLARE_METATYPE(TimeFrames)

QDebug operator<<(QDebug debug, const TimeFrame &timeFrame);
QDebug operator<<(QDebug debug, const TimeFrames &timeFrames);

#endif // TIMEFRAME_H
